
//#include <avr\portpins.h>
#include <avr/io.h>

#define byte(b7,b6,b5,b4,b3,b2,b1,b0) ((b7)*128+(b6)*64+(b5)*32+(b4)*16+(b3)*8+(b2)*4+(b1)*2+(b0))

#define port_IN					0
#define port_OUT				1
#define port_AD					0
#define SI_PULLUP		      	1
#define NO_PULLUP			    0
#define	port_HIGH				1
#define port_LOW				0




// ---------------------------------------------------------------------------
//         		PORTS DEFINITIONS SERVE PER DEFINITE SE SONO IN OUT O AD
//------------------------------------------------------------------------------
//oooooooooooooooooooooooooooooooooooo
//|
//|	PORT ATTRIBUTES
//|
//oooooooooooooooooooooooooooooooooooo

//-----------------
//---- PORTA A ----
//-----------------
	 // DDRA ------------------ VPORT1 ---------------------	 
#define DRA0	port_IN 
#define DRA1	port_IN 
#define DRA2	port_IN 
#define DRA3	port_IN 
#define DRA4	port_IN 
#define DRA5	port_IN 
#define DRA6	port_IN 
#define DRA7	port_IN 
#define DDRA_DEF	byte(DRA7,DRA6,DRA5,DRA4,DRA3,DRA2,DRA1,DRA0)
	 // PORTA
#define PPA0	port_LOW  
#define PPA1	port_LOW
#define PPA2	port_LOW
#define PPA3	port_LOW
#define PPA4	port_LOW  
#define PPA5	port_LOW
#define PPA6	port_LOW
#define PPA7	port_LOW
#define PORTA_DEF	byte(PPA7,PPA6,PPA5,PPA4,PPA3,PPA2,PPA1,PPA0)
//ooooooooooooooooooooooooooooooooooooooooo
//o   DEFINITION FOR PORT OF LCD
//ooooooooooooooooooooooooooooooooooooooooo
/*
#define DEF_VPORT_Data_LCD       PORTCFG_VP1MAP_PORTA_gc    //VPORT1 = PORTC define virtualport1 on portc
#define DATA_lcd_port            VPORT1_OUT
#define DATA_lcd_DIR             DDRA_DEF
#define DATA_lcd_VALUE           PORTA_DEF
*/

//-----------------
//---- PORTA B ----
//-----------------
#define DRB0	port_AD        //in NTC (have to be enabled also portQ
#define DRB1	port_AD        //in potentiometer
#define DRB2	port_OUT       //DAC0
#define DRB3	port_OUT       //DAC1
#define DRB4	port_IN       //JTAG
#define DRB5	port_IN       //JTAG
#define DRB6	port_IN       //JTAG
#define DRB7	port_IN       //JTAG
#define DDRB_DEF	byte(DRB7,DRB6,DRB5,DRB4,DRB3,DRB2,DRB1,DRB0)
	 // PORTA
#define PPB0	port_LOW     //IN ntc (NOTE: ntc HAVE TO BE ENABLED BY PORTQ)
#define PPB1	port_LOW      //IN POTENTOMETER
#define PPB2	port_LOW      //DAC0
#define PPB3	port_LOW      //DAC1
#define PPB4	port_LOW      //JTAG
#define PPB5	port_LOW      //JTAG
#define PPB6	port_LOW      //JTAG 
#define PPB7	port_LOW      //JTAG
#define PORTB_DEF	byte(PPB7,PPB6,PPB5,PPB4,PPB3,PPB2,PPB1,PPB0)
//ooooooooooooooooooooooooooooooooooooooooo
//o   DEFINITION FOR PORT F  FOR UART PC
//ooooooooooooooooooooooooooooooooooooooooo
//#define DEF_MIC_WP_DAC_CS_DIR       DDRB_DEF
//#define DEF_MIC_WP_DAC_CS_VALUE     PORTB_DEF
#define   PORT_DAC0_1    PORTB_DEF    //the port for dac is B 


//-----------------
//---- PORTA C ----
//-----------------
	 // DDRC ++++ ------ VPORT0 --------
#define DRC0	port_IN        //NOT CONNECTED
#define DRC1	port_OUT       //CS AT45   
#define DRC2	port_OUT       //usb UART TX
#define DRC3	port_IN        //usb UART RX
#define DRC4	port_IN        //usb SS (i DON'T KNOW IF IT'S OUT OR IN)
#define DRC5	port_OUT       //MOSI      |AT45
#define DRC6	port_IN        //MISO      |DATAFLASH
#define DRC7	port_OUT       //CK        |                 
#define DDRC_DEF	byte(DRC7,DRC6,DRC5,DRC4,DRC3,DRC2,DRC1,DRC0)
	 // PORTD
#define PPC0	port_LOW       //NOT USED
#define PPC1	port_HIGH      //CS AT45
#define PPC2	port_LOW       //usb UART TX
#define PPC3	SI_PULLUP      //USB UART RX
#define PPC4	port_HIGH      //SS  (ALREADY HAVE A PULL UP ON XPLAIN)	 
#define PPC5	SI_PULLUP      //MOSI       | 			
#define PPC6	port_LOW       //MISO    	|AT45	
#define PPC7	SI_PULLUP      //SCK        |DATAFLASH		
#define PORTC_DEF	byte(PPC7,PPC6,PPC5,PPC4,PPC3,PPC2,PPC1,PPC0)
//ooooooooooooooooooooooooooooooooooooooooo
//o   DEFINITION FOR PORT OF at45 AND UART
//ooooooooooooooooooooooooooooooooooooooooo
#define DEF_VPORT_WP_PRES_SD     PORTCFG_VP0MAP_PORTC_gc
#define CS2AT45_WP_PRES_SD       VPORT0_OUT
#define CS2AT45_WP_PRES_SD_DIR   DDRC_DEF
#define CS2AT45_WP_PRES_SD_VALUE PORTC_DEF
/*
#define DEF_VPORT_PORT_CS_WR_RD   PORTCFG_VP0MAP_PORTC_gc //DEFINE VPORT0 for PortD
#define General_CS_WR_RD          VPORT0_OUT
#define General_CS_WR_RD_DIR      DDRC_DEF
#define General_CS_WR_RD_VALUE    PORTC_DEF
*/


//---------------
//-----------------
//---- PORTA D ----
//-----------------
	 // DDRD ++++
#define DRD0	port_IN       //
#define DRD1	port_IN       //
#define DRD2	port_IN       //RX uart
#define DRD3	port_OUT      //TX uart
#define DRD4	port_IN       //
#define DRD5	port_IN       //
#define DRD6	port_IN       //
#define DRD7	port_IN       //
#define DDRD_DEF	byte(DRD7,DRD6,DRD5,DRD4,DRD3,DRD2,DRD1,DRD0)
	 // PORTD
#define PPD0	SI_PULLUP      //
#define PPD1	SI_PULLUP      //
#define PPD2	SI_PULLUP      //RX uart
#define PPD3	port_LOW       //TX uart
#define PPD4	SI_PULLUP      //
#define PPD5	SI_PULLUP      //
#define PPD6	SI_PULLUP      //
#define PPD7	SI_PULLUP      //
#define PORTD_DEF	byte(PPD7,PPD6,PPD5,PPD4,PPD3,PPD2,PPD1,PPD0)
//ooooooooooooooooooooooooooooooooooooooooo
//o   DEFINITION FOR PORT OF uart
//ooooooooooooooooooooooooooooooooooooooooo
#define DEF_UART_SD_PORT_DIR        DDRD_DEF
#define DEF_UART_SD_PORT_VALUE      PORTD_DEF
/*
#define DEF_VPORT_TS2046_SD_UART  PORTCFG_VP2MAP_PORTD_gc //DEFINE VPORT2 for PortD
#define PORT_TS2046_SD_UART       VPORT2_OUT
#define IN_PORT_TS2046_SD_UART    VPORT2_IN
#define PORT_TS2046_SD_UART_DIR   DDRD_DEF
#define PORT_TS2046_SD_UART_VALUE PORTD_DEF
*/


//-----------------
//---- PORTA E ----
//-----------------
//NOTE: ON XPLAIN PORTE ARE THE LEDS acrive low
	 // DDRE ------------ VPORT 3 ----------------
#define DRE0	port_OUT  
#define DRE1	port_OUT  
#define DRE2	port_OUT  
#define DRE3	port_OUT  
#define DRE4	port_OUT  
#define DRE5	port_OUT     
#define DRE6	port_OUT     
#define DRE7	port_OUT     
#define DDRE_DEF	byte(DRE7,DRE6,DRE5,DRE4,DRE3,DRE2,DRE1,DRE0)
	 // PORTE
#define PPE0	port_HIGH    
#define PPE1	port_HIGH   
#define PPE2	port_HIGH   
#define PPE3	port_HIGH   
#define PPE4	port_HIGH    
#define PPE5	port_HIGH    
#define PPE6	port_HIGH   
#define PPE7	port_HIGH    
#define PORTE_DEF	byte(PPE7,PPE6,PPE5,PPE4,PPE3,PPE2,PPE1,PPE0)
//ooooooooooooooooooooooooooooooooooooooooo
//o   DEFINITION FOR PORT E  FOR DATA FLASH
//ooooooooooooooooooooooooooooooooooooooooo
/*
#define DEF_VPORT_WP_PRES_SD     PORTCFG_VP3MAP_PORTE_gc    //VPORT1 = PORTC define virtualport1 on portc
#define CS2AT45_WP_PRES_SD       VPORT3_OUT
#define CS2AT45_WP_PRES_SD_DIR   DDRE_DEF
#define CS2AT45_WP_PRES_SD_VALUE PORTE_DEF
*/
//-----------------
//---- PORTA F ----   NO VIRTUAL PORT
//-----------------
//NOTE: on XPLAIN PORTF are the pushbuttons
#define DRF0	port_IN
#define DRF1	port_IN
#define DRF2	port_IN   
#define DRF3	port_IN   
#define DRF4	port_IN   
#define DRF5	port_IN   
#define DRF6	port_IN   
#define DRF7	port_IN   
#define DDRF_DEF	byte(DRF7,DRF6,DRF5,DRF4,DRF3,DRF2,DRF1,DRF0)
	 // PORTF
#define PPF0	SI_PULLUP  
#define PPF1	SI_PULLUP  
#define PPF2	SI_PULLUP    
#define PPF3	SI_PULLUP   
#define PPF4	SI_PULLUP    
#define PPF5	SI_PULLUP    
#define PPF6	SI_PULLUP    
#define PPF7	SI_PULLUP    
#define PORTF_DEF	byte(PPF7,PPF6,PPF5,PPF4,PPF3,PPF2,PPF1,PPF0)
//ooooooooooooooooooooooooooooooooooooooooo
//o   DEFINITION FOR PORT F  FOR UART PC
//ooooooooooooooooooooooooooooooooooooooooo
//#define DEF_UART_SD_PORT_DIR        DDRF_DEF
//#define DEF_UART_SD_PORT_VALUE      PORTF_DEF

//-----------------
//---- PORTA Q ----   NO VIRTUAL PORT
//-----------------
//NOTE: on XPLAIN PORTF are the pushbuttons
#define DRQ0	port_IN
#define DRQ1	port_IN
#define DRQ2	port_OUT  //EN ntc
#define DRQ3	port_OUT  //EN audio
#define DDRQ_DEF	byte(0,0,0,0,DRQ3,DRQ2,DRQ1,DRQ0)
	 // PORTF
#define PPQ0	SI_PULLUP  
#define PPQ1	SI_PULLUP  
#define PPQ2	port_LOW   //(ENABLE NTC    
#define PPQ3	port_HIGH  //enable Audio   
#define PORTQ_DEF	byte(0,0,0,0,PPQ3,PPQ2,PPQ1,PPQ0)
//oooooooooooooooooooooooooooooooooooooooo
//o
//o   PORT DEFINITIONS FOR COLOR LCD
//o
//oooooooooooooooooooooooooooooooooooooooo
/*
#define RS_lcd_port              General_CS_WR_RD   //VPORT0 = PORTC
#define RS_lcd_pin               PC0 

#define	CS_lcd_port              General_CS_WR_RD   //VPORT0 = PORTC
#define CS_lcd_pin               PC1   

#define WR_lcd_port              General_CS_WR_RD   //VPORT0 = PORTC 
#define WR_lcd_pin               PC2    

#define RD_lcd_port              General_CS_WR_RD   //VPORT0 = PORTC
#define RD_lcd_pin		         PC3	

#define RESET_lcd_port           PORTB_OUT//General_CS_WR_RD   //VPORT0 = PORTC
#define RESET_lcd_pin            PB1 //PC4	

*/

//oooooooooooooooooooooooooooooooooooo
//|
//|	PORT DEFINITIONS FOR AT45DBxx
//|
//oooooooooooooooooooooooooooooooooooo
// not used on Xplain #define PIN_WR_PROT_AT45	PE0    //Write Protect of AT45DBxx
//not used on Xplain  #define PORT_WR_PROT_AT45	CS2AT45_WP_PRES_SD //NEW REDEFINED! //Write Protect of AT45DBxx

// not used on Xplain #define PIN_RST_AT45		PE1    //Reset of		  AT45DBxx
//not used on Xplain#define PORT_RST_AT45		CS2AT45_WP_PRES_SD //NEW REDEFINED! //Reset of AT45DBxx

#define PIN_CS_AT45			PC1    //Chip Select of   AT45DBxx 
#define	PORT_CS_AT45		CS2AT45_WP_PRES_SD //Virtual port!!!


//oooooooooooooooooooooooooooooooooooooooooo
//o
//o		PORT DEFINITIONS FOR TOUCH SCREEN
//o
//oooooooooooooooooooooooooooooooooooooooooo
/*
#define	CS_TS_port         PORT_TS2046_SD_UART   
#define CS_TS_pin          PD4   

#define	INT_TS_port        IN_PORT_TS2046_SD_UART   
#define INT_TS_pin         PD0   
*/
//oooooooooooooooooooooooooooooooooooooooo
//o
//o   PORT DEFINITIONS FOR SD CARD
//o
//oooooooooooooooooooooooooooooooooooooooo
/*
#define	CS_SD_card_port              PORTF_OUT //(NEW!!!) //PORT_TS2046_SD_UART   //VPORT2 = PORTD
#define CS_SD_card_pin               PF4   //(NEW!!!)//PD1   
*/


/*
//oooooooooooooooooooooooooooooooooooo
//|
//|	PORT DEFINITIONS FOR PUSHBUTTONS
//|
//oooooooooooooooooooooooooooooooooooo
#define PLAY_BUTTON			PA5   //push button Play
#define REC_BUTTON			PA6   //push button Rec
#define ERASE_BUTTON		PA7   //push button Erase
 
#define PIN_PLAY			PINA  //push button Play
#define PIN_REC				PINA  //push button Rec
#define	PIN_ERASE			PINA  //push button Erase
*/
